#include "widget.h"

Widget::Widget(QApplication *parent) {
 //Создаём сетку и элементы интерфейса:
 QGridLayout *myLayout = new QGridLayout();
 displaystring = new QLineEdit();
 displaystring->setMaxLength(10);
 stackList = new QTextEdit();
 stackList->setReadOnly(true);
 errorLabel = new QLabel();
 b1 = new QPushButton("+");
 b2 = new QPushButton("-");
 b3 = new QPushButton("C");
 b4 = new QPushButton("=");
 //Формируем 3 строки сетки элементов:
 myLayout->addWidget(displaystring, 0, 0, 1, 4);
  //нулевые строка и столбец, занимаем 1 строку и 4 столбца
 myLayout->addWidget(stackList, 1, 0, 1, 4);
  //первая строка и нулевой столбец, занимаем 1 строку и 4 столбца
 myLayout->addWidget(errorLabel, 2, 0, 1, 4);
  //вторая строка и нулевой столбец, занимаем 1 строку и 4 столбца
 myLayout->addWidget(b1,3,0); //в третьей строке 4 виджета-кнопки
 myLayout->addWidget(b2,3,1);
 myLayout->addWidget(b3,3,2);
 myLayout->addWidget(b4,3,3);
 //Подключаем сетку к основному виджету и настраиваем окно:
 setLayout(myLayout);
 this->setWindowTitle("Стек из чисел и его суммирование");
 this->setMinimumSize(320,240);
 this->setMaximumSize(800,600);
 this->resize(640,480);
 this->setGeometry(QStyle::alignedRect( //availableGeometry() устарела
  Qt::LeftToRight,Qt::AlignCenter,this->size(),
  parent->screens().first()->geometry()));
 //Соединяем сигналы о нажатии кнопок со слотами обработки:
 connect(b1, SIGNAL(clicked()), this, SLOT(b1Clicked()));
 connect(b2, SIGNAL(clicked()), this, SLOT(b2Clicked()));
 connect(b3, SIGNAL(clicked()), this, SLOT(b3Clicked()));
 connect(b4, SIGNAL(clicked()), this, SLOT(b4Clicked()));
 //Нажатие Enter в поле ввода равно кнопке "+":
 connect(displaystring, SIGNAL(returnPressed()), this, SLOT(b1Clicked()));
}

Widget::~Widget() {}

void Widget::b1Clicked() { //"+"
 QString s = this->displaystring->text();
 bool validate;
 /* double n = */ s.toDouble(&validate); //Строку в число
 if (!validate) {
  this->errorLabel->setText("Введено не число: [" + s + "]");
  return;
 }
 stack.append(s);

 this->stackList->append(s);
 this->errorLabel->setText("Элемент добавлен");
}

void Widget::b2Clicked() { //"-"
 int n = stack.size();
 if (n > 0) {
  stack.remove(n - 1);
  //Список был бы удобнее, но мы не могли бы выделить все строки "одним кликом".
  //Теперь придётся "вручную" удалять последнюю строку из QTextEdit:
  this->removeLastLineFromQTextEdit (stackList);
  this->errorLabel->setText("Элемент удалён");
 }
 else this->errorLabel->setText("Стек пуст");
}

void Widget::b3Clicked() { //"C"
 this->displaystring->clear();
 this->errorLabel->clear();
}

void Widget::b4Clicked() { //"="
 double summa = 0.;
 for (int i = 0; i < stack.size(); i++) {
  QString s = stack.at(i);
  summa += s.toDouble();
 }
 this->errorLabel->setText("Сумма = "+QString::number(summa,'f',2));
  //Число в строку, вещественное, 2 знака в дробной части
}

void Widget::removeLastLineFromQTextEdit (QTextEdit *q) {
 //Удалить последнюю строку из QTextEdit
 q->setFocus();
 QTextCursor storedCursorPos = q->textCursor();
 q->moveCursor(QTextCursor::End, QTextCursor::MoveAnchor);
 q->moveCursor(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
 q->moveCursor(QTextCursor::End, QTextCursor::KeepAnchor);
 q->textCursor().removeSelectedText();
 q->textCursor().deletePreviousChar();
 q->setTextCursor(storedCursorPos);
}
